(* CGI from Christian Queinnec's ICFP00 paper. Fig 1.
   We only replaced no-longer used francs with yens.
*)
open Cgi
open Kcgi

(*
open Kcgi_mem
;;
#load "cgi.cmo";;
#load "kcgi.cmo";;
#load "kcgi_mem.cmo";;
*)

(*
open Kcgi_tty
;;
#load "cgi.cmo";;
#load "kcgi.cmo";;
#load "kcgi_tty.cmo";;
*)

open Kcgi_p

module MAIN(S:KCGI) = struct
  open S

  (* Where all the template files are *)
  let template_dir = "/home/oleg/caml-web";;
  (*
  let template_dir = "/home/oleg/caml-web/tty";;
  *)
  (* Continuations are stored in /tmp *)


 let main () =
  let henv = inquire "currency_read_rate.html" [] in
  let curr_name = answer "curr-name" henv vstring in
  let curr_rate = answer "rate" henv vfloat in
  let henv = inquire "currency_read_yen.html" [("curr-name",curr_name)] in
  let amount = answer "curr-amount" henv vfloat in
  let yen_amount = amount /. curr_rate in
    inquire_finish "currency_result.html"
    [("curr-name",curr_name);("rate",string_of_float curr_rate);
     ("curr-amount",string_of_float amount); 
     ("yen-amount", string_of_float yen_amount)];
    exit 0				(* unreachable *)
end

let () = 
  let module M = Run(MAIN) in M.run ()
;;


